<template>
  <b-container id="tos">
    <b-card :title="$t('page.tos.title')">
      <!-- Terms of Use -->
      <b-card-body>
        <i18n-t scope="global" keypath="page.tos.tos_body" tag="p">
          <template #tos>
            <a id="tosLink" :href="termsOfServiceUrl" target="_blank">
              <strong>{{ $t("page.tos.tos") }}</strong>
            </a>
          </template>
        </i18n-t>
        <b-form-checkbox
          id="TosAccepted"
          v-model="isTosChecked"
          :disabled="areTosAccepted"
        >
          {{ $t("page.tos.checkbox.tos") }}
        </b-form-checkbox>
      </b-card-body>

      <div class="v_gapped_container">
        <b-button
          id="confirmBtn"
          variant="primary"
          :disabled="!isTosChecked || areTosAccepted"
          @click="accept"
        >
          {{ $t("buttons.confirm") }}
        </b-button>

        <b-button @click="cancel">
          {{ $t("buttons.cancel") }}
        </b-button>
      </div>
    </b-card>
  </b-container>
</template>

<script lang="ts">
// import the store for current module
import useLoginStore from "../store";
import useUserStore from "@/modules/user/store";

export default defineComponent({
  setup() {
    const loginStore = useLoginStore();
    const userStore = useUserStore();

    return { loginStore, userStore };
  },

  data() {
    return {
      isTosChecked: false,
    };
  },

  computed: {
    areTosAccepted(): boolean | undefined {
      return this.userStore.user?.areToSAccepted ?? undefined;
    },
    termsOfServiceUrl(): string | undefined {
      return this.loginStore.currentTosVersion?.href;
    },
  },

  watch: {
    areTosAccepted() {
      this.isTosChecked = this.areTosAccepted ? true : false;

      // Navigate away from ToS page
      if (this.areTosAccepted) {
        this.$router.replace({ name: "home" });
      }
    },
  },

  async created() {
    this.isTosChecked = this.areTosAccepted ? true : false;
  },

  methods: {
    async accept() {
      if (this.isTosChecked) {
        await this.loginStore.acceptToS();
        await this.userStore.retrieveUser();
        // Navigation guards will take care of navigating away
        // from ToS page when the user info is refreshed.
      }
    },
    cancel() {
      this.loginStore.logout();
    },
  },
});
</script>

<style scoped>
.form-check-input:after {
  content: " *";
  color: var(--bs-form-invalid-color);
}
</style>
